unit unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, jpeg;

type
  TForm1 = class(TForm)
    Image1: TImage;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  Pict1 = 'tiling1.bmp';
  Pict2 = 'tiling2.bmp';

procedure TForm1.FormCreate(Sender: TObject);
begin
  // Load a picture at start of the application
  Image1.Picture.LoadFromFile(Pict1);
  // Trick: remember number of picture in property TAG of image component
  Image1.Tag := 1;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  X, Y: integer;
begin
  Y := 0;
  // Fill background with rows of pictures until
  // entire client-height of form is covered
  while Y < ClientHeight do begin
    // First column/row position is already covered
    // by Image component
    if Y = 0 then X := Image1.Width
    else          X := 0;
    // Copy picture of Image component as many times
    // as necessary to cover entire client-width of form
    while X < Left + ClientWidth do begin
      Canvas.Draw(X, Y, Image1.Picture.Bitmap);
      X := X + Image1.Width;
    end;
    Y := Y + Image1.Height;
   end;
end;

// Some optional tricks for repositioning components when
// the form is resized by the user
procedure TForm1.FormResize(Sender: TObject);
begin
  // Center button horizontally,
  // at a fixed distance from bottom of the form
  BitBtn1.Left := (ClientWidth - BitBtn1.Width) div 2;
  BitBtn1.Top  := ClientHeight - BitBtn1.Height - 14;
  // Center labels horizontally
  Label1.Left  := (ClientWidth - Label1.Width) div 2;
  Label2.Left  := (ClientWidth - Label2.Width) div 2;
  // Position second label a bit above button
  Label2.Top   := BitBtn1.Top - 29;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  if Image1.Tag = 1 then begin
    Image1.Picture.LoadFromFile(Pict2);
    Image1.Tag := 2;
  end
  else begin
    Image1.Picture.LoadFromFile(Pict1);
    Image1.Tag := 1;
  end;
  Repaint;
end;  

end.
